#ifndef GIMMELIB_COPYSTUFF_H
#define GIMMELIB_COPYSTUFF_H

/* flags for various copy routines */
#define GCP_NOT_ITEXT	(1L << 1)       /* don't copy IntuiText struct(s) */
#define GCP_NOT_IMAGE	(1L << 2)       /* don't copy Image struct(s) */
#define GCP_NOT_STRING	(1L << 8)       /* don't copy actual string */
#define GCP_NOT_BYTES	(1L << 9)       /* don't copy (image) byte data */
#define GCP_NOT_POINTS	(1L << 10)      /* don't copy (border) points data */
#define GCP_NOT_TEXTATTR  (1L << 11)    /* don't copy (itext) textattr */

#define GCP_NOT_STRUCTS (0x000ffL)      /* don't copy "sub-structures" */
#define GCP_NOT_DATA	(0x0ff00L)      /* don't copy "low-level" data */

#define GCP_SALVAGE	(1L << 16)      /* try to copy as much as possible */
#define GCP_DEFAULT	(0L)            /* copy everything */


#endif !GIMMELIB_COPYSTUFF_H
