#ifndef GIMMELIB_MINTERM_H
#define GIMMELIB_MINTERM_H

#define GIM_MINTERM_COPY	0x0c0	/* copy source; ignore dest */
#define GIM_MINTERM_DEST	0x0a0	/* keep dest as is */
#define GIM_MINTERM_CLEAR	0x000	/* clear dest block */
#define GIM_MINTERM_FILL	0x0f0	/* fill dest block */
#define GIM_MINTERM_OR		0x0e0	/* mix source and dest */
#define GIM_MINTERM_MIX 	GIM_MINTERM_OR
#define GIM_MINTERM_UNMIX	0x020	/* remove source pattern from dest */
#define GIM_MINTERM_XOR 	0x060	/* xor source and dest */
#define GIM_MINTERM_INV_SRC	0x030	/* invert source */
#define GIM_MINTERM_INV_DEST	0x030	/* invert dest */

/*  4 important bits in minterm are as follows:
 *	7  6  5  4
 *	|  |  |  -> ~src & ~dest
 *	|  |  ----> ~src &  dest
 *	|  ------->  src & ~dest
 *	---------->  src &  dest
*/

#endif !GIMMELIB_MINTERM_H
